#include "pch.h"
#include "UnderlineSpecifier.h"

// IUnknown methods
ULONG STDMETHODCALLTYPE UnderlineSpecifier::AddRef()
{
    m_refCount++;
    return m_refCount;
}

ULONG STDMETHODCALLTYPE UnderlineSpecifier::Release()
{
    m_refCount--;
    LONG newCount = m_refCount;

    if (m_refCount == 0)
        delete this;

    return newCount;
}

HRESULT STDMETHODCALLTYPE UnderlineSpecifier::QueryInterface(_In_ REFIID riid,
                                                            _Outptr_ void** ppOutput)
{
    *ppOutput = nullptr;
    HRESULT hr = S_OK;

    if (riid == __uuidof(IUnknown))
    {
        *ppOutput = this;
        AddRef();
    }
    else
    {
        hr = E_NOINTERFACE;
    }
    return hr;
}
