#pragma once

class UnderlineSpecifier : public IUnknown
{
public:
    UnderlineSpecifier(int underlineCount, int strikethroughCount) :
        m_refCount(0),
        m_underlineCount(underlineCount),
        m_strikethroughCount(strikethroughCount)
    {
    }

    // IUnknown methods
    virtual ULONG STDMETHODCALLTYPE AddRef() override;
    virtual ULONG STDMETHODCALLTYPE Release() override;
    virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, 
                                                     void **ppvObject) override;

    int GetUnderlineCount() { return m_underlineCount; }
    int GetStrikethroughCount() { return m_strikethroughCount; }

private:
    LONG m_refCount;
    int  m_underlineCount;
    int  m_strikethroughCount;
};
